package FDN::Common::Mail;

use strict;
use Exporter ;

our @ISA = ( 'Exporter' ) ;
our @EXPORT = qw (
	envoie_mail
	set_mail_config
	@mails
	);
our @EXPORT_ID = qw (
	);
our @EXPORT_OK;
our %EXPORT_TAG;

use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Web::TemplateParse qw(parse remplace);
use Mail::Sendmail;

my $cfg;
our @mails;

sub set_mail_config($) {
	my ( $file ) = @_;
	$cfg = Load_Config($file);
	return $cfg;
}

sub envoie_mail($$$;$) {
	my ( $email, $type, $vars, $more ) = @_;
	die "No configuration" if ! defined $cfg;

	my $dir   = $cfg->{'global'}->{'tpldir'};
#Config_Key ('adsl/global.cfg','dirs','mailtpl');
	my $tpl   = $cfg->{'mail-'.$type}->{'template'};
#Config_Key ('adsl/subs/mail.cfg','mail-'.$type,'template');
	my $sujet = $cfg->{'mail-'.$type}->{'subject'};
#Config_Key ('adsl/subs/mail.cfg','mail-'.$type,'subject');
	my $from  = $cfg->{'mail-'.$type}->{'from'};
#Config_Key('adsl/global.cfg','mail','from');
	my $bcc   = $cfg->{'mail-'.$type}->{'bcc'};
#Config_Key('adsl/global.cfg','mail','bcc');
	my $dflt  = $cfg->{'mail-'.$type}->{'default-to'};

	$from = $cfg->{'global'}->{'from'} if ! defined $from;
	$from = 'default@example.com' if ! defined $from;

	$vars = { %$vars, %$more } if defined $more;

	my $texte = remplace($dir.'/'.$tpl,$vars,1);
	
#	my $forceto = Config_Key ('adsl/global.cfg','mail','forceto');
	if ( $email && $cfg->{'global'}->{'forceto'} ) {
		$sujet .= " [was for $email]";
		$email = $cfg->{'global'}->{'forceto'};
	}
	
	my $to;
	if ( defined $email ) {
		$to = $email;
	} else {
		$to = $dflt;
	}
	$sujet = parse($sujet, $vars, $vars);
	my $ret;
	my $testing = $cfg->{'global'}->{'testing'};
	my $message = [
			'To' => $to,
			'From' => $from,
			'Message' => $texte,
			'Subject' => $sujet,
			'Bcc' => $bcc
			];
	if ( defined $vars->{'tel'} ) {
		push @$message, 'X-Fdn-Tel';
		push @$message, $vars->{'tel'};
	}
	if ( ! $testing ) {
		$ret = sendmail ( @$message );
	} else {
		$ret = 1;
		push @mails, { @$message };
	}
	if ( !$ret ) {
		error "Echec d'envoi d'un mail.";
		error $Mail::Sendmail::error;
		error $Mail::Sendmail::log;
		error "To: $to";
		error "From: $from";
		error "Subject: $sujet";
		error "Bcc: $bcc";
		error "X-Fdn-Tel: $vars->{tel}" if defined $vars->{'tel'};
		error "MSG\n$texte\nMSG";
	} else {
		info "Mail type $type envoye a $to";
	}
	return $ret;
}

1;
