package FDN::Common::Sys;

use strict;
use warnings;
use base 'Exporter';

our @EXPORT = qw (
	proc_self_stat
);


my @keys = ( 'pid', 'comm', 'state', 'ppid', 'pgrp', 'session', 'tty_nr', 'tpgid', 'flags', 'minflt',
'cminflt', 'majflt', 'cmajflt', 'utime', 'stime', 'cutime', 'cstime', 'priority', 'nice', 'num_threads',
'itrealvalue', 'starttime', 'vsize', 'rss', 'rsslim', 'startcode', 'endcode', 'startstack', 'kstkesp',
'kstkeip', 'signal', 'blocked', 'sigignore', 'sigcatch', 'wchan', 'nswap', 'cnswap', 'exit_signal',
'processor', 'rt_priority', 'policy', 'delayacct_blkio_ticks', 'guest_time', 'cguest_time' );

sub __read_proc_self_stat {
	my $res = {};

	open FH, '<', '/proc/self/stat';
	my $line = <FH>;
	close FH;

	my @vals = split / /, $line;
	for my $k ( @keys ) {
		$res->{$k} = shift @vals;
	}
	return $res;
}

sub proc_self_stat {
	my ( $key ) = @_;

	my $res = __read_proc_self_stat();
	if ( $key ) {
		return $res->{$key};
	}

	return $res;	
}

1;
